<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph::BidirectionalIterator&lt; T, I &gt; Class Template Reference</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="classes.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="classes.html"><span>Class&nbsp;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="namespace_sylph.html">Sylph</a>::<a class="el" href="class_sylph_1_1_bidirectional_iterator.html">BidirectionalIterator</a>
  </div>
</div>
<div class="contents">
<h1>Sylph::BidirectionalIterator&lt; T, I &gt; Class Template Reference</h1><!-- doxytag: class="Sylph::BidirectionalIterator" --><!-- doxytag: inherits="ForwardIterator&lt; T, I &gt;" --><code>#include &lt;<a class="el" href="_iterator_8h-source.html">Sylph/Core/Iterator.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Sylph::BidirectionalIterator&lt; T, I &gt;:</div>
<div class="dynsection">
<p><center><img src="class_sylph_1_1_bidirectional_iterator__inherit__graph.png" border="0" usemap="#_sylph_1_1_bidirectional_iterator_3_01_t_00_01_i_01_4__inherit__map" alt="Inheritance graph"></center>
<map name="_sylph_1_1_bidirectional_iterator_3_01_t_00_01_i_01_4__inherit__map">
<area shape="rect" id="node2" href="class_sylph_1_1_forward_iterator.html" title="Sylph::ForwardIterator\&lt; T, I \&gt;" alt="" coords="20,83,241,112"><area shape="rect" id="node4" href="class_sylph_1_1_object.html" title="The root of all classes." alt="" coords="75,5,187,35"></map>
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="class_sylph_1_1_bidirectional_iterator-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual reference&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_forward_iterator.html#0cfbb6d989c3cbbd37947fb1fa68ee24">current</a> () const =0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><b>OVERRIDE THIS METHOD</b> Returns a reference to the object the iterator is currently pointing at.  <a href="#0cfbb6d989c3cbbd37947fb1fa68ee24"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_forward_iterator.html#c51a9015adb5e22568530c70efd6ff40">next</a> () const =0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><b>OVERRIDE THIS METHOD</b> Sets the iterator one place forward.  <a href="#c51a9015adb5e22568530c70efd6ff40"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_forward_iterator.html#0c368995da59e9b3a2074bfccf8ac708">hasNext</a> () const =0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><b>OVERRIDE THIS METHOD</b> Tells wheter there are any objects left in the collection.  <a href="#0c368995da59e9b3a2074bfccf8ac708"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_forward_iterator.html#6bc12e11b0e540d8788e8eab0cad19cd">equals</a> (const I &amp;other) const =0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><b>OVERRIDE THIS METHOD</b> Tells wheter this Iterator is equal to any other Iterator over the same type of collection.  <a href="#6bc12e11b0e540d8788e8eab0cad19cd"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="1448ef46fc3bf3ac2e65ed03eba0cb33"></a><!-- doxytag: member="Sylph::BidirectionalIterator::_end_reached_" ref="1448ef46fc3bf3ac2e65ed03eba0cb33" args="" -->
bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_forward_iterator.html#1448ef46fc3bf3ac2e65ed03eba0cb33">_end_reached_</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Do not use or modify! <br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
<h3>template&lt;class T, class I&gt;<br>
 class Sylph::BidirectionalIterator&lt; T, I &gt;</h3>

<dl compact><dt><b><a class="el" href="todo.html#_todo000007">Todo:</a></b></dt><dd>Write documentation! </dd></dl>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="0cfbb6d989c3cbbd37947fb1fa68ee24"></a><!-- doxytag: member="Sylph::BidirectionalIterator::current" ref="0cfbb6d989c3cbbd37947fb1fa68ee24" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual reference <a class="el" href="class_sylph_1_1_forward_iterator.html">Sylph::ForwardIterator</a>&lt; T , I  &gt;::current           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [pure virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<b>OVERRIDE THIS METHOD</b> Returns a reference to the object the iterator is currently pointing at. 
<p>
Note that no beyond-the-end checking needs to be done, this is all done automagically for you. <dl class="return" compact><dt><b>Returns:</b></dt><dd>The object this iterator is currently pointing at. </dd></dl>

</div>
</div><p>
<a class="anchor" name="6bc12e11b0e540d8788e8eab0cad19cd"></a><!-- doxytag: member="Sylph::BidirectionalIterator::equals" ref="6bc12e11b0e540d8788e8eab0cad19cd" args="(const I &amp;other) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="class_sylph_1_1_forward_iterator.html">Sylph::ForwardIterator</a>&lt; T , I  &gt;::equals           </td>
          <td>(</td>
          <td class="paramtype">const I  &amp;&nbsp;</td>
          <td class="paramname"> <em>other</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [pure virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<b>OVERRIDE THIS METHOD</b> Tells wheter this Iterator is equal to any other Iterator over the same type of collection. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>other</em>&nbsp;</td><td>An other ForwardIterator to compare this one against. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd><em>true</em> iff the two iterators are completely equal (i.e. they iteratate over the same collection and currently point to the same object), false otherwise. </dd></dl>

</div>
</div><p>
<a class="anchor" name="0c368995da59e9b3a2074bfccf8ac708"></a><!-- doxytag: member="Sylph::BidirectionalIterator::hasNext" ref="0c368995da59e9b3a2074bfccf8ac708" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="class_sylph_1_1_forward_iterator.html">Sylph::ForwardIterator</a>&lt; T , I  &gt;::hasNext           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [pure virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<b>OVERRIDE THIS METHOD</b> Tells wheter there are any objects left in the collection. 
<p>
This method should not take the past-the-end item into account. <dl class="return" compact><dt><b>Returns:</b></dt><dd><em>true</em> true if there are any next items, <em>false</em> if there are no more items left. </dd></dl>

</div>
</div><p>
<a class="anchor" name="c51a9015adb5e22568530c70efd6ff40"></a><!-- doxytag: member="Sylph::BidirectionalIterator::next" ref="c51a9015adb5e22568530c70efd6ff40" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="class_sylph_1_1_forward_iterator.html">Sylph::ForwardIterator</a>&lt; T , I  &gt;::next           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [pure virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<b>OVERRIDE THIS METHOD</b> Sets the iterator one place forward. 
<p>
Note that no beyond-the-end checking needs to be done, this is all done automagically for you. 
</div>
</div><p>
</div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
